/*
 * Private memory handling - just wraps malloc currently
 *
 * Copyright 1996-2002 netFluid Technology Ltd
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.1.1.1 $  $Date: 2003/01/10 23:16:02 $
 * ---------------------------------------------------------------------------
 */

#include <phlib/xl_config.h>
#include <sys/types.h>
#include <stdlib.h>
#if HAVE_UNISTD_H
# include <sys/types.h>
# include <unistd.h>
#endif

#include <phlib/xl_types.h>
#define XL_WITHIN_MALLOC_C
#include <phlib/xl_malloc.h>
#undef XL_WITHIN_MALLOC_C

static long memcount = 0;

/* ------------------------------------------------------------------------ */
void *
xl_malloc( size_t size ) 
{
  void *ptr = malloc( size );
  memcount++;
#ifdef DEVELOPMENT
  printf( "xl_malloc: size %d, ptr: %x   (Level: %ld)\n", size, (int)ptr, memcount );
#endif
  return ptr;
}

/* ------------------------------------------------------------------------ */

void
xl_free( void * ptr ) 
{
#ifdef DEVELOPMENT
  printf( "xl_free: ptr: %x  (level: %ld)", (int)ptr, memcount );
#endif

  if( memcount <= 0 ) { 

#ifdef DEVELOPMENT
    printf( "UNBALANCED MALLOC/FREE PAIR!\n" );
#endif

    ptr = 0;
  }

  if( ptr != 0 ) {
    free(ptr);
    ptr = 0;
    memcount--;
  }
#ifdef DEVELOPMENT
  printf( "  (after: %x)\n", (int)ptr );
#endif
}

/* ------------------------------------------------------------------------ */
/* end */
